Subject: Re: [PATCH net-next 2/2] net: dsa: mv88e6xxx: Set link down when changing speed

From: Andrew Lunn <[email-masked]>
Date: Fri, 27 Mar 2020 22:26:08 +0100

> > Hi Russell
> > 
> > So the problem here is that CPU and DSA ports should default to up and
> > at their fastest speed. During setup, the driver is setting the CPU
> > port to 1G and up. Later on, phylink finds the fixed-link node in DT,
> > and then sets the port to 100Mbps as requested.
> > 
> > How do you suggest fixing this? If we find a fixed-link, configure it
> > first down and then up?
> 
> I think this is another example of DSA fighting phylink in terms of
> what's expected.
> 
> The only suggestion I've come up so far with is to avoid calling
> mv88e6xxx_port_setup_mac() with forced-link-up in
> mv88e6xxx_setup_port() if we have phylink attached.

Hi Russell

Yes, that might work. But it is a solution specific to mv88e6xxx. I
guess other switches could have a similar issue.

Is it really that bad to add the link down as i proposed? Do we even
have a guarantee the port is down before phylink starts configuring
it, for all switch drivers?

    Andrew